// Softmidi.h
// Softmidi implements softbits that allow Midi
// messages and data to be processed
//
// 11/16/2014 - initial release
// http://moddersandrockers.com/littlebits/2.php
//
#define MIDIVER 1.0
#define BASENOTE 48  // C3

extern int mididevs;    // bit map of available midi devices

// the midi data that is visible.
extern int mchan;
extern int mstatus;
extern int mdata1;
extern int mdata2;

// midi softbits
extern void midi_setup(int n);
extern void input_midi_sub();  // look for and process midi data bytes
//
extern void input_midi(int s);  // softbits interface
extern void input_serial();  // raw serial data
extern void output_serial();  // raw serial data
//
extern void midi_chan0(int s); // filter midi channel 0, send rest
extern void midi_cc19(int s);  // process midi control change
extern void midi_attack(int s);  // process midi control change
extern void midi_release(int s);  // process midi control change
extern void midi_cc(int cont, int s);  // process midi control change
extern void midi_gate(int send);
extern void midi_velocity(int send);
//
extern void midi_notegate(int n, int send);  // when note n, send gate
extern void midi_glide(int n);    // use counter to glide.
extern void midi_sustain(int n);  // ignore note offs.
//
extern void wire_recv();      // 46 xmit status 

//
extern void out_midicc(); // output a midi CC message
extern void midi_out_noteon(); // output a midi noteon
extern void midi_out_noteoff(); // output a midi noteoff

////
extern int midilastnote;
extern int midigate;


