// softbits.h
//
// 11/16/2014 - initial release
// http://moddersandrockers.com/littlebits/2.php
//
// this file declares the information needed later.
#define VERSION "1.2"

#ifdef YUNBIT
#ifndef LEONARDO
#define LEONARDO 1
#endif
#endif

// use by the storage allocation.
#ifndef NCHAINS
#define NCHAINS 20
#endif

// define the data storage used.
extern int data[NCHAINS];  
extern int chain;      // used to hold the active chain number.
extern int curchain;   // the current chain value
extern int startdata[NCHAINS]; // power uses this value as start value.
extern int counters[NCHAINS]; // counters - 16 bit, top 8 bits is output

// declare the modules in softbits.ino
//
// soft_setup
//
extern void soft_setup();

// power bits
//
extern void power_on( int n);
extern void power_off();

// input bits
extern void input_a0();
extern void input_a1();
extern void input_d0();
extern void input_ax(int n);
extern void input_dx(int n);

// output bits
// these are digital outputs
// use digitalWrite
extern void output_d1();
extern void output_d5();
extern void output_d9();
extern void output_d10();
extern void output_d11();
extern void output_d12();
extern void output_d13();
extern void output_dx(int n);

// oscillator stuff
extern void oscillator_squelch();
extern void midi_cv(int root);


// these are PWM pseudo analog outputs
// using analogWrite
extern void output_a5();
extern void output_a9();
extern void output_a11();
extern void output_ax(int n);

// logic bits
//
extern void logic_and(int n);
extern void logic_or(int n);
extern void logic_not();
extern void logic_nand(int n);
extern void logic_nor(int n);
extern void logic_xor(int n);

// wire bits
//
//
extern void wire_split(int n);
extern void wire_loop();

// arithmetic bits
//
extern void arith_plus(int n);
extern void arith_minus(int n);
extern void arith_times(int n);
extern void arith_divide(int n);
extern void arith_diff(int n);

// special arith bits
extern void arith_counter(int n);

// setup 
extern void use_d5();
extern void use_d9();
extern void use_d1();
extern void use_d0();
extern void use_trace();

//


